var umylist={
	mylistId:false,//マイリスト名先頭にID追加

	mylist:{},
	Ulist:{},
	Umylistlist:{},
	data:{},
	cache:{},
	tagDic:{},
	setVariable:function(){
		var U=this,D,movies,tgs;
		$.ajax({
			url:'/umylist/json',
			type:'GET',
			dataType:'json',
			success:function(json){
				for(var x=0;x<json.length;x++){
					D=[],movies=json[x].movies;
					for(var y=0;y<movies.length;y++)D.push({"tid":movies[y].threadid,"mid":movies[y].movieid});
					U.Ulist[json[x].id]={"name":json[x].name,"moviecount":json[x].movies.length,"movies":D};
				}
				umylist.listSet();
			}
		});
		$.ajax({
			url:'/umylist/mylist/json',
			type:'GET',
			dataType:'json',
			success:function(json){
				for(var i=0;i<json.length;i++){
					U.Umylistlist[json[i].mylistid]={"id":json[i].id,"name":json[i].name};
				}
				umylist.mylistListSet();
			}
		});
		$.ajax({
			url:'/cache/cachelist.json',
			type:'GET',
			dataType:'json',
			success:function(json){
				U.cache=json;
			}
		});
		U.data=NCnl.getSt('NicoVideoData');
		U.removeStorage();
		for(var a in U.data){
			tgs=U.data[a].tags
			if(!tgs)continue;
			for(var b=0; b<tgs.length; b++){
				if(tgs[b].dic==true)U.tagDic[tgs[b].tag]=true;
			}
		}
	},
	removeStorage:function(){
		var U=this;
		for(var i in U.data){
			if(U.data[i].limit < new Date().getTime())delete U.data[i];
		}
	},
	remove:function(mylist,mid,tid){
		var U=this;
		$.ajax({
			url:'/umylist/remove',
			type:'GET',
			data:{'mylist':mylist,'mid':mid,'tid':tid},
			dataType:'json',
//			timeout:10000,
			cache:false,
			success:function(json){
				var text=json.status;
				switch(json.status){
					case 'succeeded':
						text='['+U.data[mid].title+'] を<br />削除しました';
						for(var i=0; i<U.Ulist[mylist].moviecount; i++){
							if(U.Ulist[mylist].movies[i].tid==tid){
								delete U.Ulist[mylist].movies[i];
							}
						}
						U.Ulist[mylist].moviecount=U.Ulist[mylist].moviecount-1;
						break;
					default:
						break;
				}
				$('#'+tid).css('display','none');
				$('#l'+mylist+'len').html('('+U.Ulist[mylist].moviecount+')');
				$('#state').html(text);
			}
		});
	},
	mremove:function(mylist){
		var U=this;
		$.ajax({
			url:'/umylist/mremove',
			type:'GET',
			data:{'mylist':mylist},
			dataType:'json',
//			timeout:10000,
			cache: false,
			success:function(json){
				var text=json.status;
				switch(json.status){
					case 'succeeded':
						text='['+U.Ulist[mylist].name+'] を<br />削除しました';
						delete U.Ulist[mylist];
						break;
					default:
						break;
				}
				$('#list').html('');
				$('#l'+mylist).parent().parent().css('display','none');
				$('#state').html(text);
			}
		});
	},
	rename:function(mylist,name){
		var U=this;
		$.ajax({
			url:'/umylist/rename',
			type:'GET',
			data:{'mylist':mylist,'name':encodeURIComponent(name)},
			dataType:'json',
//			timeout:10000,
			cache: false,
			success:function(json){
				var text=json.status;
				switch(json.status){
					case 'succeeded':
						text='['+U.Ulist[mylist].name+'] を<br />['+name+'] に<br />リネームしました';
						$('#headerTitle').html(name);
						U.Ulist[mylist].name=name;
						break;
					default:
						break;
				}
				$('#l'+mylist).html(name);
				$('#state').html(text);
			}
		});
	},
	mylistRemove:function(mylist){
		var U=this;
		$.ajax({
			url:'/umylist/mylist/remove',
			type:'GET',
			data:{'mylist':mylist},
			dataType:'json',
//			timeout:10000,
			cache: false,
			success:function(json){
				var text=json.status;
				switch(json.status){
					case 'succeeded':
						text='['+U.Umylistlist[mylist].name+'] を<br />削除しました';
						delete U.Umylistlist[mylist];
						break;
					default:
						break;
				}
				$('#list').html('');
				$('#ml'+mylist).parent().parent().css('display','none');
				$('#state').html(text);
			}
		});
	},
	mylistRename:function(mylist,name){
		var U=this;
		$.ajax({
			url:'/umylist/mylist/rename',
			type:'GET',
			data:{'mylist':mylist,'name':name},
			dataType:'json',
//			timeout:10000,
			cache: false,
			success:function(json){
				var text=json.status;
				switch(json.status){
					case 'succeeded':
						text='['+U.Umylistlist[mylist].name+'] を<br />['+name+'] に<br />リネームしました';
						$('#headerTitle').html(name);
						U.Umylistlist[mylist].name=name;
						break;
					default:
						break;
				}
				$('#ml'+mylist).html(name);
				$('#state').html(text);
			}
		});
	},
	updateinfo:function(mylist,I){
		var U=this,id=[],list=U.Ulist[mylist],tid0,mid0,tid1=[],mid1=[],tid,mid,html='';
		$('#state').html('読み込み中');
		for(var a=0;a<list.moviecount;a++){
			id.push({"tid":list.movies[a].tid,"mid":list.movies[a].mid});
		}
		for(var b=0;b<id.length;b++){
			tid0=id[b]['tid'],mid0=id[b]['mid'];
			if(!U.data[mid0]||!U.data[mid0][tid0])tid1.push(tid0),mid1.push(mid0);
		}
		if(tid1.length!=0){
			U.setDataVA(tid1.join(','));
			for(var i=0;i<tid1.length;i++){
				if(!U.data[mid1[i]]||!U.data[mid1[i]][tid1[i]])U.setDataTi(tid1[i],mid1[i]);
			}
		}
		for(var i=0;i<id.length;i++){
			tid=id[i].tid,mid=id[i].mid;
			if(U.data[mid][tid]){
				html+=U.makeMitem(tid,mid,mylist);
			}else{
				U.data[mid]={};
				U.data[mid][tid]={"threadDef":false,"communityId":'',"channelId":''};
				html+=U.makeMitem(tid,mid,mylist);
			}
		}
		var html2=	'<select id="sort">'+
						'<option value="title_0">タイトル昇順</option>'+
						'<option value="title_1">タイトル降順</option>'+
						'<option value="date_0">投稿が新しい順</option>'+
						'<option value="date_1">投稿が古い順</option>'+
						'<option value="view_0">再生が多い順</option>'+
						'<option value="view_1">再生が少ない順</option>'+
						'<option value="comment_0">コメントが多い順</option>'+
						'<option value="comment_1">コメントが少ない順</option>'+
						'<option value="mylist_0">マイリスト登録が多い順</option>'+
						'<option value="mylist_1">マイリスト登録が少ない順</option>'+
						'<option value="sec_0">時間が長い順</option>'+
						'<option value="sec_1">時間が短い順</option>'+
					'</select>'+
					'<div id="sortButton" class="button" onclick="umylist.sort(\''+mylist+'\',\'umylist\')">ソート</div>'+
					'<div class="button" onclick="umylist.mremove('+mylist+')">このマイリストを削除</div>'+
					'<div class="button" onclick="umylist.rename('+mylist+',prompt(\'新しい名前を入力してください\',\'\'))">このマイリストをリネーム</div>';
		$('#list').html('<ul>'+html+'</ul>');
		$('#headerButton').html(html2);
		$('#headerTitle').html(U.Ulist[mylist].name);
		$('.active').removeClass('active');
		$(I.parentNode.parentNode).addClass('active');
		$('#state').html('読み込み完了');
		NCnl.setSt('NicoVideoData',U.data);
	},
	makeMitem:function(tid,mid,mylist){
		var D=this.data[mid],T=this.data[mid][tid],tags='',cache=this.cache;
		if(D.tags){
			for(var i=0;i<D.tags.length;i++){
				tags+=	'<span class="tagFrm">'+(!D.tags[i].lock?'':'<span class="tagLock"></span>')+
						'<a class="tag" href="http://www.nicovideo.jp/tag/'+D.tags[i].tag+'">'+D.tags[i].tag+'</a>'+
						'<a class="'+(!D.tags[i].dic?'tagDicDis':'tagDicEna')+'" href="http://dic.nicovideo.jp/a/'+D.tags[i].tag+'"></a></span>';
			}
		}
		var html=	'<li id="'+tid+'" class="movieItem">'+
						'<div class="movie">'+
							'<div class="info">'+
								'<div class="thumbFrm">'+
									'<div class="thumb">'+
										'<img src="'+(D.thumb||'')+'" class="thumbImg" />'+
										'<div class="time">'+(D.sec||'')+'</div>'+
										(cache[mid]?'<div class="cache"></div>':
										 cache[mid+'low']?'<div class="economy"></div>':'')+
										(!D.deleted?'':'<div class="deleted"></div>')+
									'</div>'+
								'</div>'+
								'<div class="movieFrm">'+
									'<div class="movieinfo">'+
										'<span class="date">投稿日:'+D.date+'</span><span class="view">再生数:'+D.view+'</span><span class="res">コメント:'+D.comment+'</span><span class="mylist">マイリスト:'+D.mylist+'</span>'+
										(T.threadDef?'':
										T.channelId?'<span class="channel_id">チャンネル:<a href="http://ch.nicovideo.jp/channel/ch'+T.channelId+'" onMouseOver="return popThumb2(\'ch'+T.channelId+'\', 0)" onMouseOut="return nd()">ch'+T.channelId+'</a>':
										 T.communityId?'<span class="community_id">コミュ:<a href="http://com.nicovideo.jp/community/co'+T.communityId+'" onMouseOver="return popThumb2(\'co'+T.communityId+'\', 0)" onMouseOut="return nd()">co'+T.communityId+'</a>':
										 '<span class="mymemory">[id:'+tid+']</span>')+
									'</div>'+
									'<div class="title"><a href="http://www.nicovideo.jp/watch/'+(T.threadDef?mid:tid)+'"'+
	//								' onMouseOver="return popThumb2(\''+(D.threadDef?D.id:D.threadId)+'\', 0)" onMouseOut="return nd()"'+
									'>'+(D.title||mid)+'</a></div>'+
									'<div class="tags">'+tags+'</div>'+
								'</div>'+
							'</div>'+
							'<div class="desc">'+(D.desc||'')+'</div>'+
						'</div>'+
						(mylist?'<div class="button"" onclick="umylist.remove('+mylist+',\''+mid+'\',\''+tid+'\')">削除</div>':'')+
					'</li>';
		return html;
	},
	listSet:function(){
		var U=this,html='',id,name,moviecount;
		for(var i in U.Ulist){
			id=i,name=U.Ulist[i].name,moviecount=U.Ulist[i].moviecount;
			html +=	'<li class="resItem">'+
						(umylist.mylistId?'<span class="mylistId">['+id+']</span>':'')+
						'<span class="route">└</span>'+
						'<span>'+
							'<span id="l'+id+'" class="mylistName" onclick="umylist.updateinfo('+id+',this),$(\'html,body\').scrollTop(0)">'+name+'</span>'+
							'<span id="l'+id+'len">('+moviecount+')</span>'+
						'</span>'+
					'</li>';
		}
		$('#uList').html('<ul id="uListUl">'+html+'</ul>');
	},
	mylistListSet:function(){
		var U=this,html='',mylist,id,name;
		for(var i in U.Umylistlist){
			mylistid=i,id=U.Umylistlist[i].id,name=U.Umylistlist[i].name;
			html +=	'<li class="resItem">'+
						'<span class="route">└</span>'+
						'<span>'+
							'<span id="ml'+mylistid+'" class="mylistName" onclick="umylist.officialMylistShow('+mylistid+',this,\'umylist\')">'+name+'</span>'+
							'<span id="ml'+mylistid+'len"></span>'+
						'</span>'+
					'</li>';
		}
		$('#uMylistList').html('<ul id="uMylistListUl">'+html+'</ul>');
	},
	officialSet:function(){
		$('#state').html('読み込み中');
		$.ajax({
			url:'/pr_Redirect_flapi.nicovideo.jp/api/mylistgroup/list',
			type:'GET',
			dataType:'json',
//			timeout:1000,
			cache:false,
			async:false,
			success:function(json){
				var html='<li class="resItem">'+
							'<span class="route">└</span>'+
							'<span>'+
								'<span id="oDef" class="mylistName" onclick="umylist.officialMylistShow(\'def\',this)">とりあえずマイリスト</span>'+
								'<span id="oDeflen"></span>'+
							'</span>'+
						'</li>';
				$.each(json.mylistgroup, function(key,value) {
					html+=	'<li class="resItem">'+
								'<span class="route">└</span>'+
								'<span>'+
									'<span id="o'+value.id+'" class="mylistName" onclick="umylist.officialMylistShow('+value.id+',this)">'+value.name+'</span>'+
									'<span id="o'+value.id+'len"></span>'+
								'</span>'+
							'</li>';
				});
				$('#officialMylist').html('<ul id="officialMylistUl">'+html+'</ul>');
			}
		});
		$('#state').html('読み込み完了');
	},
	officialMylistShow:function(id,I,type){
		$('#state').html('読み込み中');
		var U=this;
		if(!U.mylist[id]){
			if(id=='def'){U.setDataDeflist()}else{U.setDataPlaylist(id,type);}
		}
		var html='',threadid,id;
		for(var i=0;i<U.mylist[id].length;i++){
			html+=U.makeMitem(U.mylist[id][i]['tid'],U.mylist[id][i]['mid']);
		}
		$('#list').html('<ul>'+html+'</ul>');
		var html2=	'<select id="sort">'+
						'<option value="title_0">タイトル昇順</option>'+
						'<option value="title_1">タイトル降順</option>'+
						'<option value="date_0">投稿が新しい順</option>'+
						'<option value="date_1">投稿が古い順</option>'+
						'<option value="view_0">再生が多い順</option>'+
						'<option value="view_1">再生が少ない順</option>'+
						'<option value="comment_0">コメントが多い順</option>'+
						'<option value="comment_1">コメントが少ない順</option>'+
						'<option value="mylist_0">マイリスト登録が多い順</option>'+
						'<option value="mylist_1">マイリスト登録が少ない順</option>'+
						'<option value="sec_0">時間が長い順</option>'+
						'<option value="sec_1">時間が短い順</option>'+
					'</select>';
		if(type=='umylist'){
			var html3=	'<div class="button" onclick="umylist.mylistRemove('+id+')">このマイリストを削除</div>'+
						'<div class="button" onclick="umylist.mylistRename('+id+',prompt(\'新しい名前を入力してください\',\'\'))">このマイリストをリネーム</div>';
			$('#headerButton').html(html2+'<div id="sortButton" class="button" onclick="umylist.sort(\''+id+'\',\'official\')">ソート</div>'+html3);
			$('#headerTitle').html(U.Umylistlist[id].name);
		}else if(id=='def'){
			$('#headerButton').html(html2+'<div id="sortButton" class="button" onclick="umylist.sort(\'def\',\'def\')">ソート</div>');
			$('#headerTitle').html('とりあえずマイリスト');
		}else{
			$('#headerButton').html(html2+'<div id="sortButton" class="button" onclick="umylist.sort(\''+id+'\',\'official\')">ソート</div>');
			$('#headerTitle').html($('#o'+id).html());
		}
		$('.active').removeClass('active');
		$(I.parentNode.parentNode).addClass('active');
		$('html,body').scrollTop(0);
		$('#state').html('読み込み完了');
		NCnl.setSt('NicoVideoData',U.data);
	},
	sort:function(mylist,type){
		var U=this,A=[];
		var S=$('#sort').val().split('_');
		var D=(type=='umylist')?U.Ulist[mylist].movies:U.mylist[mylist];
		for(var i=0;i<D.length;i++){
			A.push({'tid':D[i].tid,'mid':D[i].mid});
			A[i][S[0]]=U.data[D[i].mid][S[0]];
		}
		var Sort=function(a,b){
			var A=a[S[0]],B=b[S[0]];
			if(S[0]=='view'||S[0]=='mylist'||S[0]=='comment')A=A.split(',').join('')-0,B=B.split(',').join('')-0;
			if(S[1]==0){
				return (A<B)?1:-1;
			}else{
				return (A>B)?1:-1;
			}
		}
		A.sort(Sort);
		var html='';
		for(var j=0;j<A.length;j++)html+=U.makeMitem(A[j].tid,A[j].mid);
		$('#list').html('<ul>'+html+'</ul>');
	},
/*******************************************************************************/
	setDataVA:function(id){
		var U=this;
		$.ajax({
			url:'/pr_Redirect_i.nicovideo.jp/v3/video.array',
			type:'GET',
			data:{'v':id},
			dataType:'xml',
//			timeout:10000, //タイムアウトあると割と迷惑（各自設定すべき）
			async:false,
			error:function(e){
				$('#list').html('なんかエラー(時間切れかなんか)');
				$('#state').html('事故');
			},
			success:function(xml){
				$(xml).find('video_info').each(function(){
					var xml=$(this),tags=[];
					var mid=xml.find('video > id').text();
					var tid=xml.find('thread > id').text();
					var tm=xml.find('first_retrieve').text().match(/^20(\d{2})-(\d{2})-(\d{2})T(.{8})/);
					var lsec=xml.find('length_in_seconds').text()-0;
					var sec=('0'+parseInt(lsec/3600)).slice(-2)+':'+
							('0'+parseInt(lsec%3600/60)).slice(-2)+':'+
							('0'+parseInt(lsec%60)).slice(-2);
					xml.find('tag_info').each(function(){
						if($(this).find('area').text()=='jp'){
							tags.push({"tag":$(this).find('tag').text(),"dic":U.tagDic[$(this).find('tag').text()],"lock":false});
						}
					})
					var D={
						"limit":new Date().getTime()+(1000*60*60*24),
						"deleted":xml.find('deleted').text()=='0'?false:true,
						"title":xml.find('title').text(),
						"desc":xml.find('description').text(),
						"sec":sec,
						"thumb":xml.find('thumbnail_url').text(),
						"date":'20'+tm[1]+'/'+tm[2]+'/'+tm[3]+' '+tm[4],
						"view":xml.find('view_counter').text().replace(/\d(?=(\d{3})+$)/g,'$&,'),
						"mylist":xml.find('mylist_counter').text().replace(/\d(?=(\d{3})+$)/g,'$&,'),
						"comment":xml.find('num_res').text().replace(/\d(?=(\d{3})+$)/g,'$&,'),
						"tags":tags
					};
					if(!U.data[mid])U.data[mid]={};
					for(var i in D)U.data[mid][i]=D[i];
					U.data[mid][tid]={
						"threadDef":xml.find('default_thread').text()==tid?true:false,
						"communityId":xml.find('community_id').text(),
						"channelId":xml.find('channel_id').text()
					}
				});
			}
		});
	},
	setDataTi:function(tid,mid){
		var U=this;
		$.ajax({
			url:'/pr_Redirect_ext.nicovideo.jp/api/getthumbinfo',
			type:'GET',
			data:{'v':tid},
			dataType:'xml',
//			timeout:1000,
			async:false,
			cache:false,
			success:function(xml){
				var xml=$(xml),tags=[];
				var tm = xml.find('first_retrieve').text().match(/^20(\d{2})-(\d{2})-(\d{2})T(.{8})/);
				var len=xml.find('length').text().split(':');
				var lsec=len[0]*60 + len[1]*1;
				var sec=('0'+parseInt(lsec/3600)).slice(-2)+':'+
						('0'+parseInt(lsec%3600/60)).slice(-2)+':'+
						('0'+parseInt(lsec%60)).slice(-2);
				xml.find('tags[domain="jp"]:first > tag').each(function(){
					tags.push({"tag":$(this).text(),"dic":U.tagDic[$(this).text()],"lock":$(this).attr('lock')=='1'?true:false});
				})
				var D={
					"limit":new Date().getTime()+(1000*60*60*24),
					"deleted":false,
					"title":xml.find('title').text(),
					"desc":xml.find('description').text(),
					"sec":sec,
					"thumb":xml.find('thumbnail_url').text(),
					"date":'20'+tm[1]+'/'+tm[2]+'/'+tm[3]+' '+tm[4],
					"view":xml.find('view_counter').text().replace(/\d(?=(\d{3})+$)/g,'$&,'),
					"mylist":xml.find('mylist_counter').text().replace(/\d(?=(\d{3})+$)/g,'$&,'),
					"comment":xml.find('comment_num').text().replace(/\d(?=(\d{3})+$)/g,'$&,'),
					"tags":tags
				};
				if(!U.data[mid])U.data[mid]={};
				for(var i in D)U.data[mid][i]=D[i];
				U.data[mid][tid]={
					"threadDef":(xml.find('thumb_type').text()!='video'||xml.find('video_id').text().slice(0,1)!=('sm'||'nm'))?false:true,
					"communityId":xml.find('community_id').text(),
					"channelId":xml.find('channel_id').text()
				}
			}
		});
	},
/********************/
	unixtimeToString:function(unix){
		var d=new Date(unix*1000);
		var month=('0'+(d.getMonth()+1)).slice(-2);
		var day=('0'+d.getDate()).slice(-2);
		var hour=('0'+d.getHours()).slice(-2);
		var min=('0'+d.getMinutes()).slice(-2);
		var sec=('0'+d.getSeconds()).slice(-2);
		return d.getFullYear()+'/'+month+'/'+day+' '+hour+':'+min+':'+sec;
	},
	setDataDeflist:function(){
		var U=this;
		U.mylist['def']=[];
		$.ajax({
			url:'/pr_Redirect_flapi.nicovideo.jp/api/deflist/list',
			type:'GET',
			dataType:'json',
//			timeout:1000,
			async:false,
			cache:false,
			success:function(json){
				$('#oDeflen').html('('+json.mylistitem.length+')');
				$.each(json.mylistitem, function(key,value) {
					var itm=value.item_data;
					var tid=value.item_id;
					var mid=itm.video_id;
					var lsec=itm.length_seconds-0;
					var sec=('0'+parseInt(lsec/3600)).slice(-2)+':'+
							('0'+parseInt(lsec%3600/60)).slice(-2)+':'+
							('0'+parseInt(lsec%60)).slice(-2);
					var D={
						"limit":new Date().getTime()+(1000*60*60*24),
						"deleted":itm.deleted=='0'?false:true,
						"title":itm.title,
						"sec":sec,
						"thumb":itm.thumbnail_url,
						"date":U.unixtimeToString(itm.first_retrieve),
						"view":itm.view_counter.replace(/\d(?=(\d{3})+$)/g,'$&,'),
						"mylist":itm.mylist_counter.replace(/\d(?=(\d{3})+$)/g,'$&,'),
						"comment":itm.num_res.replace(/\d(?=(\d{3})+$)/g,'$&,'),
					};
					if(!U.data[mid])U.data[mid]={};
					for(var i in D)U.data[mid][i]=D[i];
					U.data[mid][tid]={
						"threadDef":itm.group_type=='default'?true:false
					}
					U.mylist['def'].push({"tid":tid,"mid":mid});
				});
			}
		});
	},
	setDataPlaylist:function(id,type){
		var U=this;
		U.mylist[id]=[];
		$.ajax({
			url:'/pr_Redirect_flapi.nicovideo.jp/api/getplaylist/mylist/'+id,
			type:'GET',
			dataType:'json',
//			timeout:1000,
			async:false,
			cache:false,
			success:function(json){
				$((type=='umylist'?'#ml':'#o')+id+'len').html('('+json.items.length+')')
				$.each(json.items, function(key,value) {
					var itm=value;
					var tid=itm.thread_id;
					var mid=itm.video_id;
					var lsec=itm.length_seconds-0;
					var sec=('0'+parseInt(lsec/3600)).slice(-2)+':'+
							('0'+parseInt(lsec%3600/60)).slice(-2)+':'+
							('0'+parseInt(lsec%60)).slice(-2);
					var D={
						"limit":new Date().getTime()+(1000*60*60*24),
						"deleted":itm.deleted=='0'?false:true,
						"title":itm.title,
						"desc":itm.description,
						"sec":sec,
						"thumb":itm.thumbnail_url,
						"date":U.unixtimeToString(itm.first_retrieve),
						"view":itm.view_counter.replace(/\d(?=(\d{3})+$)/g,'$&,'),
						"mylist":itm.mylist_counter.replace(/\d(?=(\d{3})+$)/g,'$&,'),
						"comment":itm.num_res.replace(/\d(?=(\d{3})+$)/g,'$&,'),
					};
					if(!U.data[mid])U.data[mid]={};
					for(var i in D)U.data[mid][i]=D[i];
					U.data[mid][tid]={
						"threadDef":itm.video_id==itm.watch_id?true:false
					}
					U.mylist[id].push({"tid":tid,"mid":mid});
				});
			}
		});
	}
}